% Henter alle resultater fra gjenkjenningen og presenter dem som leservennlig txt-fil

disp('----------- displayMixInc.m ------------');

% filnavn til parametfil inputVar.lis
path_inputVar = '/u/studenter/fasselan/HMM_testing/Test/lists/462_set/inputVar.lis';

% Innlesing av parameter fra inputVar.lis
varArray = textread(path_inputVar,'%s');
p = str2double(char(varArray(1)));
nS = str2double(char(varArray(2)));
nM = str2double(char(varArray(3)));
vS = str2double(char(varArray(4)));
Nfiles = str2double(char(varArray(5)));
numberOfAtt = str2double(char(varArray(6)));
decRule = str2double(char(varArray(7)));
NfilesTest = str2double(char(varArray(8)));
mfcTrigger = str2double(char(varArray(9)));
antIt = str2double(char(varArray(13)));
iterationNumber = str2double(char(varArray(14)));
path = char(varArray(17));
TIMITpath = char(varArray(18));
listpath = char(varArray(19));

filepath = [path 'tempFiles/' 'recData.mat'];
load(filepath);

if p == 1
p = 'phonemes';
else
p = 'attributes';
end


if decRule == 1
decRule = 'EER';
else
decRule = 'MER';
end

if mfcTrigger == 1
mfcT = 'Feature_Vectors';
elseif mfcTrigger == 2
mfcT = 'MFCCs';
elseif mfcTrigger == 3
mfcT = 'Feature_Vectors_AND_MFCCs';
elseif mfcTrigger == 4 
mfcT = 'Feature_Vectors_(MFCC_E)';
else
mfcT = 'Feature_Vectors_(MFCC_E)_FILT';
end

% Leser inna resultater fra alle iterasjonene og legger dem i allRes
mix = [1 2 4 6 8 10 12 14 16 18 20];
allRes = zeros(numberOfAtt,11,antIt);
for i = 1:antIt

recDataMix = [path 'tempFiles/' 'recData_ItNum' int2str(i) '.mat'];
load(recDataMix);
	for attr = 1:1:numberOfAtt

	err = ((finalResNUM(1,2,attr) + finalResNUM(2,1,attr))/(finalResNUM(1,1,attr)+finalResNUM(1,2,attr)+finalResNUM(2,1,attr)+finalResNUM(2,2,attr)))*100;

	cor =  ((finalResNUM(1,1,attr) + finalResNUM(2,2,attr))/(finalResNUM(1,1,attr)+finalResNUM(1,2,attr)+finalResNUM(2,1,attr)+finalResNUM(2,2,attr)))*100;
	
	allRes(attr,1,i) = finalRes(1,1,attr);
	allRes(attr,2,i) = finalRes(1,2,attr);
	allRes(attr,3,i) = finalRes(2,1,attr);
	allRes(attr,4,i) = finalRes(2,2,attr);
	allRes(attr,5,i) = err;
	allRes(attr,6,i) = cor;
	allRes(attr,7,i) = edgeError(attr)*100;
	allRes(attr,8,i) = finalResNUM(1,1,attr);
	allRes(attr,9,i) = finalResNUM(1,2,attr);
	allRes(attr,10,i) = finalResNUM(2,1,attr);
	allRes(attr,11,i) = finalResNUM(2,2,attr);
	end
end

fid = fopen('/u/studenter/fasselan/HMM_testing/Test/lists/462_set/attributes.lis','r','b');
t = fscanf(fid,'%s\n',1);

	if(strcmp(t,'q')==1)
	attributeArray = textread('/u/studenter/fasselan/HMM_testing/Test/lists/462_set/phonemes.lis','%s');
	
	else
	attributeArray = textread('/u/studenter/fasselan/HMM_testing/Test/lists/462_set/attributes_REAL_NAMES.lis','%s');
	end
	fclose(fid);


% Presenterer resultatene
for mixI = 0:1:antIt
if mixI == 0
disp(sprintf('                     '));
disp(sprintf('      |%-19s|%-19s|%-19s|%-19s|',char(attributeArray(1)),char(attributeArray(2)),char(attributeArray(3)),char(attributeArray(4))))
else
disp(sprintf('%-6.0d|     %-8.2f(%-2.2f)|     %-8.2f(%-2.2f)|     %-8.2f(%-2.2f)|     %-8.2f(%-2.2f)|',mix(mixI),allRes(1,5,mixI),allRes(1,7,mixI),allRes(2,5,mixI),allRes(2,7,mixI),allRes(3,5,mixI),allRes(3,7,mixI),allRes(4,5,mixI),allRes(4,7,mixI)));
end

end


for mixI = 0:1:antIt
if mixI == 0
disp(sprintf('                     '));
disp(sprintf('      |%-19s|%-19s|%-19s|%-19s|',char(attributeArray(5)),char(attributeArray(6)),char(attributeArray(7)),char(attributeArray(8))));
else
disp(sprintf('%-6.0d|     %-8.2f(%-2.2f)|     %-8.2f(%-2.2f)|     %-8.2f(%-2.2f)|     %-8.2f(%-2.2f)|',mix(mixI),allRes(5,5,mixI),allRes(5,7,mixI),allRes(6,5,mixI),allRes(6,7,mixI),allRes(7,5,mixI),allRes(7,7,mixI),allRes(8,5,mixI),allRes(8,7,mixI))); 
end

end

for mixI = 0:1:antIt
if mixI == 0
disp(sprintf('                     '));
disp(sprintf('      |%-19s|%-19s|%-19s|%-19s|',char(attributeArray(9)),char(attributeArray(10)),char(attributeArray(11)),char(attributeArray(12))));
else
disp(sprintf('%-6.0d|     %-8.2f(%-2.2f)|     %-8.2f(%-2.2f)|     %-8.2f(%-2.2f)|     %-8.2f(%-2.2f)|',mix(mixI),allRes(9,5,mixI),allRes(9,7,mixI),allRes(10,5,mixI),allRes(10,7,mixI),allRes(11,5,mixI),allRes(11,7,mixI),allRes(12,5,mixI),allRes(12,7,mixI))); 
end

end
for mixI = 0:1:antIt
	if mixI == 0
	disp(sprintf('                     '));
	disp(sprintf('      |%-19s|%-19s|',char(attributeArray(13)),char(attributeArray(14))));
	else
	disp(sprintf('%-6.0d|     %-8.2f(%-2.2f)|     %-8.2f(%-2.2f)|',mix(mixI),allRes(13,5,mixI),allRes(13,7,mixI),allRes(14,5,mixI),allRes(14,7,mixI))); 
	end
end
gjennomsnittFeil = mean(allRes(:,5,antIt))

TESTFriknum = [allRes(2,8,antIt) allRes(2,9,antIt);allRes(2,10,antIt) allRes(2,11,antIt)]
TESTVokalnum = [allRes(5,8,antIt) allRes(5,9,antIt); allRes(5,10,antIt) allRes(5,11,antIt)]
TESTFriknumProsent = [allRes(2,1,antIt) allRes(2,2,antIt);allRes(2,3,antIt) allRes(2,4,antIt)]
TESTVokalnumProsent = [allRes(5,1,antIt) allRes(5,2,antIt); allRes(5,3,antIt) allRes(5,4,antIt)]


trainAllRes = zeros(numberOfAtt,8,antIt);
for i = 1:antIt
trainDataResult = [path 'tempFiles/' 'trainResult_M' int2str(mix(i)) '.mat'];
load(trainDataResult);
	for attr = 1:numberOfAtt
	trainAllRes(attr,1,i) = trainNumResult(attr,1);	
	trainAllRes(attr,2,i) = trainNumResult(attr,2);
	trainAllRes(attr,3,i) = trainNumResult(attr,3);
	trainAllRes(attr,4,i) = trainNumResult(attr,4);
	trainAllRes(attr,5,i) = trainResult(attr,1);	
	trainAllRes(attr,6,i) = trainResult(attr,2);
	trainAllRes(attr,7,i) = trainResult(attr,3);
	trainAllRes(attr,8,i) = trainResult(attr,4);
	end
end

TRENINGFrikRes = [trainAllRes(2,1,antIt) trainAllRes(2,2,antIt);trainAllRes(2,3,antIt) trainAllRes(2,4,antIt)]
TRENINGVokalRes = [trainAllRes(5,1,antIt) trainAllRes(5,2,antIt);trainAllRes(5,3,antIt) trainAllRes(5,4,antIt)]
TRENINGFrikResProsent = [trainAllRes(2,5,antIt) trainAllRes(2,6,antIt);trainAllRes(2,7,antIt) trainAllRes(2,8,antIt)]
TRENINGVokalResProsent = [trainAllRes(5,5,antIt) trainAllRes(5,6,antIt);trainAllRes(5,7,antIt) trainAllRes(5,8,antIt)]

% Lagrer data
filepath =strcat('/u/studenter/fasselan/HMM_testing/Test/Results/Result_fra_displayMix/res_',mfcT,'.mat');
save(filepath,'allRes');